#include <Tone.h>
char kind_of_data;

//arduino pins
int prpm = 2;
int pkmh = 3;
int ful  = 5;   // pwm
int tmp  = 6;   // pwm

// Tone
Tone kmh;
Tone rpm;

void setup(){
  //Setup pins
  pinMode(ful, OUTPUT);
  pinMode(tmp, OUTPUT);

  //Setup TONE
  kmh.begin(pkmh);
  rpm.begin(prpm);

  Serial.begin(115200);
  // Vorbelegung auf 50c
  analogWrite(tmp,85);
  // Vorbelegung auf 30 Ltr.
  analogWrite(ful,95);
}


void loop(){
 if(Serial.available() > 0) {
    kind_of_data = Serial.read();
    delay(1);
    int Data100 = Serial.read() - '0';
    delay(1);
    int Data10 = Serial.read()- '0';
    delay(1);
    int Data1 = Serial.read()- '0';

    //Daten anpassen: aus 1 wird 001, aus 10 wird 010 etc.
    while (Data1 < 0) {
      Data1 = Data10;
      Data10 = Data100;
      Data100 = 0;
    }

    int Data = 100*Data100 + 10*Data10 + Data1;
      //  Speed
      if (kind_of_data == 'S') {
       int Speed = map(Data,0,255,0,318);
       if(Speed > 318) {
        Speed = 318;
        kmh.play(Speed);
       }
       else if((Speed <= 318) && (Speed >= 25)) {
        kmh.play(Speed);
       }
       else if(Speed < 25) {
        kmh.stop();
       }
      }

      // RPM
      else if (kind_of_data == 'R') {
       // GameDash
       int Drehzahl = map(Data,0,700,0,350);

       if(Drehzahl > 350) {
        Drehzahl = 350;
       }
       if(Drehzahl < 025) {
        Drehzahl = 000;
       }
       rpm.play(Drehzahl);
     }

      //FUELL
      else if (kind_of_data == 'F') {
       int Tankinhalt = map(Data,0,65,13,155);

       if(Tankinhalt > 155) {
        Tankinhalt = 155;
       }
       if(Tankinhalt < 13) {
        Tankinhalt = 13;
       }
       analogWrite(ful,Tankinhalt);
     }

      //TEMP
      else if (kind_of_data == 'T') {
       int Temperatur = map(Data,0,140,140,0);
       analogWrite(tmp,Temperatur);
      }

  }
}
